/**
 * Created by andrew on 12/2/14.
 */
(function() {

  /**
   * @class
   */
  Contextly.EventsLogger = Contextly.createClass( /** @lends Contextly.EventsLogger.prototype */ {

    construct: function(experienceClient) {
      this.experienceClient = experienceClient;
    },

    getDestroyableProperties: function() {
      return [
        'experienceClient'
      ];
    },

    logEvent: function(name, params) {
      this.sendEvent(Contextly.EventsLogger.eventTypes.LOG, name, params);
    },

    emailEvent: function(name, message, params) {
      params = params || {};
      params.event_page = window.location.href;

      if (message != null) {
        params.event_message = easyXDM.getJSONObject().stringify(message);
      }

      this.sendEvent(Contextly.EventsLogger.eventTypes.EMAIL, name, params);
    },

    tweetEvent: function(name, params) {
      this.sendEvent(Contextly.EventsLogger.eventTypes.TWEET, name, params);
    },

    sendEvent: function(type, name, params) {
      params = Contextly.Utils.merge({
        event_type: type,
        event_name: name
      }, params);

      this.experienceClient.call('events', 'put', params);
    }

  });

  Contextly.EventsLogger.eventTypes = {
    EMAIL: 'email',
    LOG: 'log',
    TWEET: 'tweet'
  };

})();
