(function($) {

  /**
   * @class
   * @extends Contextly.metadataParser.BaseMultiTag
   * @extends Contextly.metadataParser.ForeignHelper
   */
  Contextly.metadataParser.DublinCore = Contextly.createClass( /** @lends Contextly.metadataParser.DublinCore.prototype */ {

    extend: [Contextly.metadataParser.BaseMultiTag, Contextly.metadataParser.ForeignHelper],

    getPropertiesMap: function() {
      return {
        title: ['DC.title'],
        author_name: ['DC.publisher'],
        pub_date: ['DC.date.published'],
        url: ['DC.identifier']
      };
    },

    getConverters: function() {
      return {
        "DC.identifier": this.convertUrlToAbsolute
      };
    },

    getTags: function(sourceKey) {
      return $('meta[name="' + sourceKey + '"][content]:first');
    },

    getTagValue: function(sourceKey, tag) {
      return tag.attr('content');
    }

  });

  Contextly.metadataFormats.push(Contextly.metadataParser.DublinCore);

})(jQuery);