/**
 * @class
 *
 * @extends Contextly.metadataProvider.Base
 */
Contextly.metadataProvider.Parsed = Contextly.createClass( /** @lends Contextly.metadataProvider.Parsed.prototype */ {

  extend: Contextly.metadataProvider.Base,

  /**
   * Returns parsed post data object.
   *
   * @function
   * @return {Contextly.metadataParser.Base}
   */
  getMetadataParser: function () {
    if (typeof this.metadataParser === 'undefined') {
      // Use our own format by default, it's also a fallback if no other
      // sources found.
      this.metadataParser = new Contextly.metadataParser.Default;

      if (!this.metadataParser.dataExists()) {
        var formats = this.getSupportedMetadataFormats();
        for (var i = 0; i < formats.length; i++) {
          var candidate = new formats[i]();

          if (candidate.dataExists()) {
            this.metadataParser = candidate;
            break;
          }
        }
      }
    }

    return this.metadataParser;
  },

  /**
   * Returns array of supported metadata formats sorted by reference.
   */
  getSupportedMetadataFormats: function() {
    return Contextly.metadataFormats;
  },

  getPostDataForKey: function(key) {
    return this.getMetadataParser()
      .getData(key);
  },

  getPostDataForKeyCount: function(key) {
    return this.getMetadataParser()
      .getCount(key);
  }

});

