(function() {

  var lastDebugId = 0;
  var BaseCallbacksGate = Contextly.CallbacksGate;

  /**
   * @class
   *
   * @extends Contextly.Proxy
   */
  Contextly.CallbacksGateDebug = Contextly.createClass( /** @lends Contextly.CallbacksGateDebug.prototype */{

    extend: Contextly.CallbacksGate,

    construct: function() {
      this.debugId = ++lastDebugId;
      this.debugLog('Created');

      BaseCallbacksGate.apply(this, arguments);
    },

    debugLog: function() {
      var args = ['Gate #' + this.debugId];
      args.push.apply(args, arguments);
      Contextly.debug.log.apply(Contextly.debug, args);
    },

    /**
     * @returns {Function}
     */
    addReason: function() {
      var result = BaseCallbacksGate.fn.addReason.apply(this, arguments);

      this.debugLog('Reason #' + this.lastId + ' added');

      return result;
    },

    onReasonAppeared: function(id) {
      if (this.reasons[id]) {
        return;
      }

      this.debugLog('Reason #' + id + ' appeared');

      BaseCallbacksGate.fn.onReasonAppeared.apply(this, arguments);
    },

    onQueueComplete: function() {
      if (this.finished) {
        return;
      }

      this.debugLog('Complete');

      return BaseCallbacksGate.fn.onQueueComplete.apply(this, arguments);
    },

    waitFor: function(gate) {
      this.debugLog('Waiting for gate #' + gate.debugId);

      return BaseCallbacksGate.fn.waitFor.apply(this, arguments);
    }

  });

  Contextly.CallbacksGate = Contextly.CallbacksGateDebug;

})();
