(function() {

  // Since we download CSS using CORS request and then insert its code directly
  // to the page, in dev mode we have to take care about relative resource URLs.
  var context = Contextly.loader.CssManager;
  var original = context.onFileDownloaded;
  context.onFileDownloaded = function(affected) {
    var baseUrl = affected.url.replace(/[^\/]+$/, '');
    affected.code = affected.code.replace(/(url\(\s*['"]?)([^"'\)]+)/gi, function(match, prefix, url) {
      if (url.match(/^(\?|#|\/|https?:\/\/)/)) {
        return match;
      }
      else {
        var result = prefix + baseUrl + url;
        return result
          .replace(/\/[^\/]+\/\.\.\/]/, '/')
          .replace(/\/\.\//, '/');

      }
    });
    return original.apply(context, arguments);
  };

})();