Contextly.loader.LibrariesManager = Contextly.createClass({

  statics: {

    construct: function() {
      this.detected = false;
      this.libraries = null;
      this.detectors = null;
    },

    setOptions: function(flags) {
      this.detected = false;
      this.libraries = Contextly.Utils.merge(this.getDefaults(), this.libraries, flags);
    },

    getFlags: function() {
      if (this.libraries == null) {
        this.libraries = this.getDefaults();
      }

      if (!this.detected) {
        this.libraries = this.detect(this.libraries);
        this.detected = true;
      }

      return this.libraries;
    },

    getDefaults: function() {
      return {
        "jquery": 'auto',
        "easyxdm": 'auto',
        "json2": 'auto',
        "webfontloader": 'auto'
      };
    },

    detect: function(libs) {
      if (this.detectors == null) {
        this.detectors = this.getDetectors();
      }

      var results = {};
      for (var name in libs) {
        if (libs[name] === 'auto' && name in this.detectors) {
          results[name] = this.detectors[name]();
        }
        else {
          results[name] = libs[name];
        }
      }
      return results;
    },

    getDetectors: function() {
      return {
        "jquery": function() {
          return !window.jQuery;
        },
        "easyxdm": function() {
          return !window.easyXDM;
        },
        "json2": function() {
          return !('JSON' in window && 'parse' in JSON && 'stringify' in JSON);
        },
        "webfontloader": function() {
          return !window.WebFont;
        }
      };
    }

  }

});