(function($) {

  /**
   * Controls post instances and their widgets.
   */
  Contextly.widget.Controller = Contextly.createClass({

    extend: Contextly.ProxyEach.prototype,

    statics: {

      construct: function() {
        this.lastInstanceId = 0;
        this.posts = {};
      },

      // TODO NOW Document args
      command: function(command, specs) {
        var allowed = {
          add: true,
          remove: true
        };
        if (!command in allowed) {
          Contextly.Utils.error('Unknown widgets command ' + command);
        }

        if (!Contextly.Utils.isArray(specs)) {
          specs = [specs];
        }

        this.each(specs, function(options) {
          options = Contextly.Utils.merge({
            context: document
          }, options);

          this[command](options);
        });
      },

      add: function(options) {
        var $context = $(options.context);
        if (!$context.length) {
          return;
        }

        // In case we have post instance attached to the same context, drop it.
        if ($context[0].ctxInstanceId != null) {
          this.remove(options);
        }

        var iid = $context[0].ctxInstanceId = ++this.lastInstanceId;
        this.posts[iid] = new Contextly.widget.Post(options);
      },

      remove: function(options) {
        var $context = $(options.context);
        if (!$context.length) {
          return;
        }

        var iid = $context[0].ctxInstanceId;
        if (iid == null || this.posts[iid] == null) {
          return;
        }

        this.posts[iid].destroy();
        delete this.posts[iid];
      }

    }

  });

})(jQuery);