(function($) {

  /**
   * @class
   * @extends Contextly.widget.BaseBlocksSnippet
   */
  Contextly.widget.FloatSnippet = Contextly.createClass( /** @lends Contextly.widget.FloatSnippet.prototype */ {

    extend: Contextly.widget.BaseBlocksSnippet,

    getWidgetStyleClass: function() {
      return 'ctx-content-float';
    },

    getLinksLimit: function() {
      return this.getSettings().links_limit;
    },

    getInnerLinkHTML: function(link) {
      var inner_html = "";
      if (this.getLinkThumbnailUrl(link)) {
        inner_html +=
          "<div class='ctx-link-image'>"
          + "<img src='" + this.escape(link.thumbnail_url) + "' class='ctx-nodefs' />"
          + "</div>";
      }

      inner_html += "<div class='ctx-link-title'><p class='ctx-nodefs'>"
        + this.getLinkIconHTML(link) + " " + link.title + "</p></div>";

      return inner_html;
    },

    getCustomCssCode: function() {
      return Contextly.widget.FloatCssCustomBuilder
        .buildCSS('.' + this.containers.getTypeClass(), this.getSettings());
    },

    getLayoutModes: function() {
      return {
        "mobile": [0, 240],
        "medium": [240, 400],
        "normal": [400, 700],
        "wide": [700]
      };
    }

  });

})(jQuery);
